<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  
			   creationComplete="creationCompleteHandler(event)" 
			   title="Cadastro de Perfil Usuario"
			  maxWidth="1200" maxHeight="700"  
			   xmlns:visual="br.com.desenv.framework.component.visual.*"   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
			   
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	
	<fx:Metadata>
		[Event(name="PerfilUsuarioIncluidoEvent")]
		[Event(name="PerfilUsuarioAtualizadoEvent")]
		[Event(name="PerfilUsuarioExcluidoEvent")]
		[Event(name="PerfilUsuarioSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import mx.collections.ArrayCollection;
			import mx.core.FlexGlobals;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.validators.Validator;
			
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.PerfilUsuario;
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			
			// Alguem passa a objeto para ca
			public var perfilUsuario : PerfilUsuario = new PerfilUsuario();
			

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
			public function moveWindow(evt:TitleWindowBoundsEvent):void 
			{
				if (evt.afterBounds.left < 0) 
				{
					evt.afterBounds.left = 0;	
				} 
				else if (evt.afterBounds.right > FlexGlobals.topLevelApplication.systemManager.getVisibleApplicationRect().width) 
				{
					evt.afterBounds.left = FlexGlobals.topLevelApplication.systemManager.getVisibleApplicationRect().width - evt.afterBounds.width;
				}
				
				if (evt.afterBounds.top < 0) 
				{
					evt.afterBounds.top = 0;
				} 
				else if (evt.afterBounds.bottom > FlexGlobals.topLevelApplication.systemManager.getVisibleApplicationRect().height) 
				{
					evt.afterBounds.top = FlexGlobals.topLevelApplication.systemManager.getVisibleApplicationRect().height - evt.afterBounds.height;
				}
			}
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
				ignTextInputDescricao.text = "";
				ignComboBoxFixoSupervisor.selectedIndex = -1;
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				
				// Se e um novo cadastro
				if (isNaN(this.perfilUsuario.id))
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					ignTextInputDescricao.text = this.perfilUsuario.descricao;

					for(var i:int = 0; i < this.listaOpcaoSupervisor.length; i++)
					{
						if (this.listaOpcaoSupervisor.getItemAt(i).codigo == this.perfilUsuario.supervisor)
						{
							ignComboBoxFixoSupervisor.selectedIndex = i;
							break;
						}
					}

				}
			}
			
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (isNaN(perfilUsuario.id) == false) 
					{
						perfilUsuario.descricao = ignTextInputDescricao.text;
						perfilUsuario.supervisor = ignComboBoxFixoSupervisor.selectedItem==null?null:ignComboBoxFixoSupervisor.selectedItem.codigo == ""?null:ignComboBoxFixoSupervisor.selectedItem.codigo;
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("perfilUsuarioService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(perfilUsuario); 
					// Se e inclusao
					} 
					else 
					{
						perfilUsuario.descricao = ignTextInputDescricao.text;

						perfilUsuario.supervisor = ignComboBoxFixoSupervisor.selectedItem==null?null:ignComboBoxFixoSupervisor.selectedItem.codigo == ""?null:ignComboBoxFixoSupervisor.selectedItem.codigo;

						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("perfilUsuarioService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(perfilUsuario); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.perfilUsuario = event.result as PerfilUsuario;
				this.dispatchEvent(new ResultEvent("PerfilUsuarioIncluidoEvent",false, true, this.perfilUsuario, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.perfilUsuario = event.result as PerfilUsuario;
				this.dispatchEvent(new Event("PerfilUsuarioAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoPerfilUsuario" property="selectedItem" required="true" source="{comboBoxSituacaoPerfilUsuario}" trigger="{comboBoxSituacaoPerfilUsuario}" triggerEvent="valueCommit"/> -->
		
		<s:ArrayCollection id="listaOpcaoSupervisor">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>

		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
					
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="720" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Descrição:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricao" styleName="labelValidacao" text="{ignTextInputDescricao.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricao" maxChars="100" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Supervisor:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoSupervisor" styleName="labelValidacao" text="{ignComboBoxFixoSupervisor.errorString}"/>
					<visual:IgnComboBoxFixo id="ignComboBoxFixoSupervisor" obrigatorio="true"  dataProvider="{listaOpcaoSupervisor}"  listaValidadorForm="{this.listaValidadorForm}"/> 
				</s:VGroup>
			</mx:GridItem>



		</mx:GridRow>		
		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>